#!/usr/local/bin/ruby
#
# $Author: cvs $
# $Date: 1999/08/23 18:40:13 $
#

=begin
$BF0:n(B
    news group$B$N0lMw$r(Bdbmfile$B$K3JG<$7$^$9!#(B
    NNTP:get_list_bydate()$B$rMxMQ$9$k$3$H$G?7$7$$(Bnews group$B$N0lMw$r99?7$7$^$9!#(B

$BF~NO(B
    DBM FILE

$B=PNO(B
    $B$J$7(B
=end

def usage
  print "Usage: #{$0} <dbm file>\n"
end

# $B0z?t$N=hM}(B
if ARGV.size != 1
  usage
  exit
end

require "nntp"
require "gdbm"

# DBM FILE$B$NL>A0$r<hF@(B
@dbname = ARGV[0]

# DBM $B%*%V%8%'%/%H$N@8@.(B
if FileTest.exist?(@dbname) # DBM FILE$B$,B8:_$9$l$P!"$=$N:G=*99?7F|(B
  @date = File.mtime(@dbname)
  p "From: " + String(@date)
end
@db = GDBM.open(@dbname)

# NNTP$B$r;H$C$F5-;v>pJs$r99?7(B
@nntp = NNTP.new
if @date
  list = @nntp.get_list_bydate(@date)
else
  list = @nntp.get_list_all
end
list.each_line {|line|
  group = line.split[0]
  @db[group] = line.chop
}
@nntp.end_session
@db.close

# $BCm!'(B $B0lMw$rF@$k$K$O(B"LIST"$B%3%^%s%I$r;H$&$3$H!#(BNEWGROUPS$B$KEO$9F|IU$1$r2a5n$K(B
# $B$7$F$b4|BT$7$?F0:n$O$7$J$$(B
